diff --git a/src/hw/sdcard.c b/src/hw/sdcard.c
index 6410340..70bb08f 100644
--- a/src/hw/sdcard.c
+++ b/src/hw/sdcard.c
@@ -507,15 +507,23 @@ sdcard_controller_setup(struct sdhci_s *regs, int prio)
         warn_noalloc();
         goto fail;
     }
-    memset(drive, 0, sizeof(*drive));
-    drive->drive.type = DTYPE_SDCARD;
-    drive->regs = regs;
-    int ret = sdcard_card_setup(drive, volt, prio);
-    if (ret) {
-        free(drive);
-        goto fail;
+
+    for (int i = 0; i < 500; i++)
+    {
+        msleep(5);
+        memset(drive, 0, sizeof(*drive));
+        drive->drive.type = DTYPE_SDCARD;
+        drive->regs = regs;
+        int ret = sdcard_card_setup(drive, volt, prio);
+        if (!ret) {
+            // Success
+            dprintf(9, "sdcard setup took %d\n", i);
+            return;
+        }
     }
-    return;
+
+    free(drive);
+
 fail:
     writeb(&regs->power_control, 0);
     writew(&regs->clock_control, 0);
